common/xfs: refactor agcount calculation for mounted filesystems
[xfstests-dev.git] / common / xfs
index 3169f8710dd706c9df3b0376280db5200c252bc8..1bce3c18f58742c5b1681f0f0dc03f3a97272c9f 100644 (file)
@@ -77,6 +77,63 @@ _scratch_mkfs_xfs_supported()
        return $mkfs_status
 }
 
+# Returns the minimum XFS log size, in units of log blocks.
+_scratch_find_xfs_min_logblocks()
+{
+       local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
+
+       # The smallest log size we can specify is 2M (XFS_MIN_LOG_BYTES) so
+       # pass that in and see if mkfs succeeds or tells us what is the
+       # minimum log size.
+       local XFS_MIN_LOG_BYTES=2097152
+
+       # Try formatting the filesystem with all the options given and the
+       # minimum log size.  We hope either that this succeeds or that mkfs
+       # tells us the required minimum log size for the feature set.
+       #
+       # We cannot use _scratch_do_mkfs because it will retry /any/ failed
+       # mkfs with MKFS_OPTIONS removed even if the only "failure" was that
+       # the log was too small.
+       local extra_mkfs_options="$* -N -l size=$XFS_MIN_LOG_BYTES"
+       eval "$mkfs_cmd $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV" \
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
+       local mkfs_status=$?
+
+       # If the format fails for a reason other than the log being too small,
+       # try again without MKFS_OPTIONS because that's what _scratch_do_mkfs
+       # will do if we pass in the log size option.
+       if [ $mkfs_status -ne 0 ] &&
+          ! grep -q 'log size.*too small, minimum' $tmp.mkfserr; then
+               eval "$mkfs_cmd $extra_mkfs_options $SCRATCH_DEV" \
+                       2>$tmp.mkfserr 1>$tmp.mkfsstd
+               mkfs_status=$?
+       fi
+
+       # mkfs suceeded, so we must pick out the log block size to do the
+       # unit conversion
+       if [ $mkfs_status -eq 0 ]; then
+               blksz="$(grep '^log.*bsize' $tmp.mkfsstd | \
+                       sed -e 's/log.*bsize=\([0-9]*\).*$/\1/g')"
+               echo $((XFS_MIN_LOG_BYTES / blksz))
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+
+       # Usually mkfs will tell us the minimum log size...
+       if grep -q 'minimum size is' $tmp.mkfserr; then
+               grep 'minimum size is' $tmp.mkfserr | \
+                       sed -e 's/^.*minimum size is \([0-9]*\) blocks/\1/g'
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+
+       # Don't know what to do, so fail
+       echo "Cannot determine minimum log size" >&2
+       cat $tmp.mkfsstd >> $seqres.full
+       cat $tmp.mkfserr >> $seqres.full
+       rm -f $tmp.mkfsstd $tmp.mkfserr
+}
+
 _scratch_mkfs_xfs()
 {
        local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
@@ -89,6 +146,7 @@ _scratch_mkfs_xfs()
        _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
        mkfs_status=$?
 
+       grep -q crc=0 $tmp.mkfsstd && _force_xfsv4_mount_options
 
        if [ $mkfs_status -eq 0 -a "$LARGE_SCRATCH_DEV" = yes ]; then
                # manually parse the mkfs output to get the fs size in bytes
@@ -193,7 +251,6 @@ _scratch_xfs_repair()
                SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
                SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -r$SCRATCH_RTDEV"
-       [ "$LARGE_SCRATCH_DEV" = yes ] && SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -t"
        $XFS_REPAIR_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
 }
 
@@ -236,7 +293,7 @@ _require_scratch_xfs_crc()
        _scratch_mkfs_xfs >/dev/null 2>&1
        _try_scratch_mount >/dev/null 2>&1 \
           || _notrun "Kernel doesn't support crc feature"
-       xfs_info $SCRATCH_MNT | grep -q 'crc=1' || _notrun "crc feature not supported by this filesystem"
+       $XFS_INFO_PROG $SCRATCH_MNT | grep -q 'crc=1' || _notrun "crc feature not supported by this filesystem"
        _scratch_unmount
 }
 
@@ -295,6 +352,7 @@ _require_xfs_db_command()
        fi
        command=$1
 
+       _scratch_mkfs_xfs >/dev/null 2>&1
        _scratch_xfs_db -x -c "help" | grep $command > /dev/null || \
                _notrun "xfs_db $command support is missing"
 }
@@ -393,8 +451,7 @@ _check_xfs_filesystem()
        # option (-t) to avoid indexing the free space trees doesn't make it pass on
        # large filesystems. Avoid it.
        if [ "$LARGE_SCRATCH_DEV" != yes ]; then
-               _xfs_check $extra_log_options $device 2>&1 |\
-                       _fix_malloc >$tmp.fs_check
+               _xfs_check $extra_log_options $device 2>&1 > $tmp.fs_check
        fi
        if [ -s $tmp.fs_check ]; then
                _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (c)"
@@ -409,7 +466,7 @@ _check_xfs_filesystem()
        if [ $? -ne 0 ]; then
                _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (r)"
                echo "*** xfs_repair -n output ***"     >>$seqres.full
-               cat $tmp.repair | _fix_malloc           >>$seqres.full
+               cat $tmp.repair                         >>$seqres.full
                echo "*** end xfs_repair output"        >>$seqres.full
 
                ok=0
@@ -422,7 +479,7 @@ _check_xfs_filesystem()
                if [ $? -ne 0 ]; then
                        _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild)"
                        echo "*** xfs_repair output ***"        >>$seqres.full
-                       cat $tmp.repair | _fix_malloc           >>$seqres.full
+                       cat $tmp.repair                         >>$seqres.full
                        echo "*** end xfs_repair output"        >>$seqres.full
 
                        ok=0
@@ -433,7 +490,7 @@ _check_xfs_filesystem()
                if [ $? -ne 0 ]; then
                        _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild-reverify)"
                        echo "*** xfs_repair -n output ***"     >>$seqres.full
-                       cat $tmp.repair | _fix_malloc           >>$seqres.full
+                       cat $tmp.repair                         >>$seqres.full
                        echo "*** end xfs_repair output"        >>$seqres.full
 
                        ok=0
@@ -478,7 +535,7 @@ _require_xfs_test_rmapbt()
 {
        _require_test
 
-       if [ "$(xfs_info "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
+       if [ "$($XFS_INFO_PROG "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
                _notrun "rmapbt not supported by test filesystem type: $FSTYP"
        fi
 }
@@ -489,7 +546,7 @@ _require_xfs_scratch_rmapbt()
 
        _scratch_mkfs > /dev/null
        _scratch_mount
-       if [ "$(xfs_info "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
+       if [ "$($XFS_INFO_PROG "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
                _scratch_unmount
                _notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
        fi
@@ -701,3 +758,129 @@ _scratch_xfs_set_sb_field()
 {
        _scratch_xfs_set_metadata_field "$1" "$2" "sb 0"
 }
+
+# Before xfsprogs commit 4222d000ed("db: write via array indexing doesn't
+# work"), xfs_db command to write a specific AGFL index doesn't work. It's a
+# bug in a diagnostic tool that is only used by XFS developers as a test
+# infrastructure, so it's fine to treat it as a infrastructure dependency as
+# all other _require rules.
+_require_xfs_db_write_array()
+{
+       local supported=0
+
+       _require_test
+       touch $TEST_DIR/$seq.img
+       $MKFS_XFS_PROG -d file,name=$TEST_DIR/$seq.img,size=512m >/dev/null 2>&1
+       $XFS_DB_PROG -x -c "agfl 0" -c "write bno[32] 78" $TEST_DIR/$seq.img \
+               >/dev/null 2>&1
+       $XFS_DB_PROG -x -c "agfl 0" -c "print bno[32]" $TEST_DIR/$seq.img \
+               | grep -q "bno\[32\] = 78" && supported=1
+       rm -f $TEST_DIR/$seq.img
+       [ $supported -eq 0 ] && _notrun "xfs_db write can't support array"
+}
+
+_require_xfs_spaceman_command()
+{
+       if [ -z "$1" ]; then
+               echo "Usage: _require_xfs_spaceman_command command [switch]" 1>&2
+               exit 1
+       fi
+       local command=$1
+       shift
+       local param="$*"
+       local param_checked=0
+       local opts=""
+
+       _require_command "$XFS_SPACEMAN_PROG" "xfs_spaceman"
+
+       testfile=$TEST_DIR/$$.xfs_spaceman
+       touch $testfile
+       case $command in
+       "health")
+               testio=`$XFS_SPACEMAN_PROG -c "health $param" $TEST_DIR 2>&1`
+               param_checked=1
+               ;;
+       *)
+               testio=`$XFS_SPACEMAN_PROG -c "help $command" $TEST_DIR 2>&1`
+       esac
+
+       rm -f $testfile 2>&1 > /dev/null
+       echo $testio | grep -q "not found" && \
+               _notrun "xfs_spaceman $command support is missing"
+       echo $testio | grep -q "Operation not supported" && \
+               _notrun "xfs_spaceman $command failed (old kernel/wrong fs?)"
+       echo $testio | grep -q "Invalid" && \
+               _notrun "xfs_spaceman $command failed (old kernel/wrong fs/bad args?)"
+       echo $testio | grep -q "foreign file active" && \
+               _notrun "xfs_spaceman $command not supported on $FSTYP"
+       echo $testio | grep -q "Inappropriate ioctl for device" && \
+               _notrun "xfs_spaceman $command support is missing (missing ioctl?)"
+       echo $testio | grep -q "Function not implemented" && \
+               _notrun "xfs_spaceman $command support is missing (missing syscall?)"
+
+       [ -n "$param" ] || return
+
+       if [ $param_checked -eq 0 ]; then
+               $XFS_SPACEMAN_PROG -c "help $command" | grep -q "^ $param --" || \
+                       _notrun "xfs_spaceman $command doesn't support $param"
+       fi
+}
+
+_scratch_get_sfdir_prefix() {
+       local dir_ino="$1"
+
+       for prefix in "u.sfdir3" "u.sfdir2" "u3.sfdir3"; do
+               if [ -n "$(_scratch_xfs_get_metadata_field \
+                               "${prefix}.hdr.parent.i4" \
+                               "inode ${dir_ino}")" ]; then
+                       echo "${prefix}"
+                       return 0
+               fi
+       done
+       _scratch_xfs_db -c "inode ${dir_ino}" -c 'p' >> $seqres.full
+       return 1
+}
+
+_scratch_get_bmx_prefix() {
+       local ino="$1"
+
+       for prefix in "u3.bmx" "u.bmx"; do
+               if [ -n "$(_scratch_xfs_get_metadata_field \
+                               "${prefix}[0].startblock" \
+                               "inode ${ino}")" ]; then
+                       echo "${prefix}"
+                       return 0
+               fi
+       done
+       _scratch_xfs_db -c "inode ${ino}" -c 'p' >> $seqres.full
+       return 1
+}
+
+#
+# Ensures that we don't pass any mount options incompatible with XFS v4
+#
+_force_xfsv4_mount_options()
+{
+       local gquota=0
+       local pquota=0
+
+       # Can't have group and project quotas in XFS v4
+       echo "$MOUNT_OPTIONS" | egrep -q "(gquota|grpquota|grpjquota=|gqnoenforce)" && gquota=1
+       echo "$MOUNT_OPTIONS" | egrep -q "(\bpquota|prjquota|pqnoenforce)" && pquota=1
+
+       if [ $gquota -gt 0 ] && [ $pquota -gt 0 ]; then
+               export MOUNT_OPTIONS=$(echo $MOUNT_OPTIONS \
+                       | sed   -e 's/gquota/QUOTA/g'      \
+                               -e 's/grpquota/QUOTA/g'    \
+                               -e 's/grpjquota=[^, ]/QUOTA/g' \
+                               -e 's/gqnoenforce/QUOTA/g' \
+                               -e "s/QUOTA/defaults/g")
+       fi
+       echo "MOUNT_OPTIONS = $MOUNT_OPTIONS" >>$seqres.full
+}
+
+# Find AG count of mounted filesystem
+_xfs_mount_agcount()
+{
+       $XFS_INFO_PROG "$1" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g'
+}